When /^I post a valid message to a random channel$/ do
  @current_channel = rand(9999999999999).to_s
  @current_channel_url = @defaults.get_valid_channel(@current_channel)
  message = { :message => { 'x' => 1 }, :channel_name => @current_channel }.to_json

  if(!defined? @expected_response)
    @expected_response = Array.new
  end

  @expected_response.push(message)

  begin
    @response = RestClient.post @current_channel_url, message, :Authentication => @defaults.get_valid_auth_header(), :content_type => :json
  rescue => e
    @response = e.response
  end
end

When /^I get messages from that channel$/ do
  @response = RestClient.get @current_channel_url, {:accept => :json}
end

Then /^receive the same message back$/ do
  @response.should == @expected_response.to_json
end

When /^I post another valid message to the same channel$/ do
  message = { :message => { 'x' => 2 }, :channel_name => @current_channel }.to_json
  @expected_response.push(message)
  begin
    @response = RestClient.post @current_channel_url, message, :Authentication => @defaults.get_valid_auth_header(), :content_type => :json
  rescue => e
    @response = e.response
  end
end

Then /^receive both messages back$/ do
  Then "receive the same message back"
end

When /^I get an empty channel$/ do
  @expected_response = Array.new
  @current_channel = rand(9999999999999).to_s
  @current_channel_url = @defaults.get_valid_channel(@current_channel)
  @response = RestClient.get @current_channel_url, {:accept => :json}
end

And /^I should receive an empty array$/ do
  Then "receive the same message back"
end

When /^I get messages from the bus/ do
  @response = RestClient.get @defaults.get_valid_bus, {:accept => :json}
end

And /^receive both messages back from both channels$/ do
  response = JSON.parse(@response)
  @expected_response.each do |item|
    response.should be_include(item)
  end
end